"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateDatabaseRequest = exports.UntagResourceResponse = exports.UntagResourceRequest = exports.TagResourceResponse = exports.TagResourceRequest = exports.RejectedRecordsException = exports.RejectedRecord = exports.RecordsIngested = exports._Record = exports.TimeUnit = exports.MeasureValue = exports.MeasureValueType = exports.ListTagsForResourceResponse = exports.ListTagsForResourceRequest = exports.ListTablesResponse = exports.ListTablesRequest = exports.ListDatabasesResponse = exports.ListDatabasesRequest = exports.Dimension = exports.DimensionValueType = exports.DescribeTableResponse = exports.DescribeTableRequest = exports.DescribeEndpointsResponse = exports.Endpoint = exports.DescribeEndpointsRequest = exports.DescribeDatabaseResponse = exports.DescribeDatabaseRequest = exports.DeleteTableRequest = exports.DeleteDatabaseRequest = exports.ResourceNotFoundException = exports.CreateTableResponse = exports.Table = exports.TableStatus = exports.CreateTableRequest = exports.RetentionProperties = exports.MagneticStoreWriteProperties = exports.MagneticStoreRejectedDataLocation = exports.S3Configuration = exports.S3EncryptionOption = exports.ValidationException = exports.ThrottlingException = exports.ServiceQuotaExceededException = exports.InvalidEndpointException = exports.InternalServerException = exports.CreateDatabaseResponse = exports.Database = exports.CreateDatabaseRequest = exports.Tag = exports.ConflictException = exports.AccessDeniedException = void 0;
exports.WriteRecordsResponse = exports.WriteRecordsRequest = exports.UpdateTableResponse = exports.UpdateTableRequest = exports.UpdateDatabaseResponse = void 0;
const TimestreamWriteServiceException_1 = require("./TimestreamWriteServiceException");
class AccessDeniedException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
exports.AccessDeniedException = AccessDeniedException;
class ConflictException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConflictException = ConflictException;
var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Tag = exports.Tag || (exports.Tag = {}));
var CreateDatabaseRequest;
(function (CreateDatabaseRequest) {
    CreateDatabaseRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateDatabaseRequest = exports.CreateDatabaseRequest || (exports.CreateDatabaseRequest = {}));
var Database;
(function (Database) {
    Database.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Database = exports.Database || (exports.Database = {}));
var CreateDatabaseResponse;
(function (CreateDatabaseResponse) {
    CreateDatabaseResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateDatabaseResponse = exports.CreateDatabaseResponse || (exports.CreateDatabaseResponse = {}));
class InternalServerException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
    }
}
exports.InternalServerException = InternalServerException;
class InvalidEndpointException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "InvalidEndpointException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidEndpointException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidEndpointException.prototype);
        this.Message = opts.Message;
    }
}
exports.InvalidEndpointException = InvalidEndpointException;
class ServiceQuotaExceededException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
        this.Message = opts.Message;
    }
}
exports.ServiceQuotaExceededException = ServiceQuotaExceededException;
class ThrottlingException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
    }
}
exports.ThrottlingException = ThrottlingException;
class ValidationException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ValidationException = ValidationException;
var S3EncryptionOption;
(function (S3EncryptionOption) {
    S3EncryptionOption["SSE_KMS"] = "SSE_KMS";
    S3EncryptionOption["SSE_S3"] = "SSE_S3";
})(S3EncryptionOption = exports.S3EncryptionOption || (exports.S3EncryptionOption = {}));
var S3Configuration;
(function (S3Configuration) {
    S3Configuration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3Configuration = exports.S3Configuration || (exports.S3Configuration = {}));
var MagneticStoreRejectedDataLocation;
(function (MagneticStoreRejectedDataLocation) {
    MagneticStoreRejectedDataLocation.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MagneticStoreRejectedDataLocation = exports.MagneticStoreRejectedDataLocation || (exports.MagneticStoreRejectedDataLocation = {}));
var MagneticStoreWriteProperties;
(function (MagneticStoreWriteProperties) {
    MagneticStoreWriteProperties.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MagneticStoreWriteProperties = exports.MagneticStoreWriteProperties || (exports.MagneticStoreWriteProperties = {}));
var RetentionProperties;
(function (RetentionProperties) {
    RetentionProperties.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RetentionProperties = exports.RetentionProperties || (exports.RetentionProperties = {}));
var CreateTableRequest;
(function (CreateTableRequest) {
    CreateTableRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateTableRequest = exports.CreateTableRequest || (exports.CreateTableRequest = {}));
var TableStatus;
(function (TableStatus) {
    TableStatus["ACTIVE"] = "ACTIVE";
    TableStatus["DELETING"] = "DELETING";
})(TableStatus = exports.TableStatus || (exports.TableStatus = {}));
var Table;
(function (Table) {
    Table.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Table = exports.Table || (exports.Table = {}));
var CreateTableResponse;
(function (CreateTableResponse) {
    CreateTableResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateTableResponse = exports.CreateTableResponse || (exports.CreateTableResponse = {}));
class ResourceNotFoundException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
var DeleteDatabaseRequest;
(function (DeleteDatabaseRequest) {
    DeleteDatabaseRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteDatabaseRequest = exports.DeleteDatabaseRequest || (exports.DeleteDatabaseRequest = {}));
var DeleteTableRequest;
(function (DeleteTableRequest) {
    DeleteTableRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteTableRequest = exports.DeleteTableRequest || (exports.DeleteTableRequest = {}));
var DescribeDatabaseRequest;
(function (DescribeDatabaseRequest) {
    DescribeDatabaseRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeDatabaseRequest = exports.DescribeDatabaseRequest || (exports.DescribeDatabaseRequest = {}));
var DescribeDatabaseResponse;
(function (DescribeDatabaseResponse) {
    DescribeDatabaseResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeDatabaseResponse = exports.DescribeDatabaseResponse || (exports.DescribeDatabaseResponse = {}));
var DescribeEndpointsRequest;
(function (DescribeEndpointsRequest) {
    DescribeEndpointsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeEndpointsRequest = exports.DescribeEndpointsRequest || (exports.DescribeEndpointsRequest = {}));
var Endpoint;
(function (Endpoint) {
    Endpoint.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Endpoint = exports.Endpoint || (exports.Endpoint = {}));
var DescribeEndpointsResponse;
(function (DescribeEndpointsResponse) {
    DescribeEndpointsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeEndpointsResponse = exports.DescribeEndpointsResponse || (exports.DescribeEndpointsResponse = {}));
var DescribeTableRequest;
(function (DescribeTableRequest) {
    DescribeTableRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeTableRequest = exports.DescribeTableRequest || (exports.DescribeTableRequest = {}));
var DescribeTableResponse;
(function (DescribeTableResponse) {
    DescribeTableResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeTableResponse = exports.DescribeTableResponse || (exports.DescribeTableResponse = {}));
var DimensionValueType;
(function (DimensionValueType) {
    DimensionValueType["VARCHAR"] = "VARCHAR";
})(DimensionValueType = exports.DimensionValueType || (exports.DimensionValueType = {}));
var Dimension;
(function (Dimension) {
    Dimension.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Dimension = exports.Dimension || (exports.Dimension = {}));
var ListDatabasesRequest;
(function (ListDatabasesRequest) {
    ListDatabasesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListDatabasesRequest = exports.ListDatabasesRequest || (exports.ListDatabasesRequest = {}));
var ListDatabasesResponse;
(function (ListDatabasesResponse) {
    ListDatabasesResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListDatabasesResponse = exports.ListDatabasesResponse || (exports.ListDatabasesResponse = {}));
var ListTablesRequest;
(function (ListTablesRequest) {
    ListTablesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTablesRequest = exports.ListTablesRequest || (exports.ListTablesRequest = {}));
var ListTablesResponse;
(function (ListTablesResponse) {
    ListTablesResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTablesResponse = exports.ListTablesResponse || (exports.ListTablesResponse = {}));
var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceRequest = exports.ListTagsForResourceRequest || (exports.ListTagsForResourceRequest = {}));
var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceResponse = exports.ListTagsForResourceResponse || (exports.ListTagsForResourceResponse = {}));
var MeasureValueType;
(function (MeasureValueType) {
    MeasureValueType["BIGINT"] = "BIGINT";
    MeasureValueType["BOOLEAN"] = "BOOLEAN";
    MeasureValueType["DOUBLE"] = "DOUBLE";
    MeasureValueType["MULTI"] = "MULTI";
    MeasureValueType["TIMESTAMP"] = "TIMESTAMP";
    MeasureValueType["VARCHAR"] = "VARCHAR";
})(MeasureValueType = exports.MeasureValueType || (exports.MeasureValueType = {}));
var MeasureValue;
(function (MeasureValue) {
    MeasureValue.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MeasureValue = exports.MeasureValue || (exports.MeasureValue = {}));
var TimeUnit;
(function (TimeUnit) {
    TimeUnit["MICROSECONDS"] = "MICROSECONDS";
    TimeUnit["MILLISECONDS"] = "MILLISECONDS";
    TimeUnit["NANOSECONDS"] = "NANOSECONDS";
    TimeUnit["SECONDS"] = "SECONDS";
})(TimeUnit = exports.TimeUnit || (exports.TimeUnit = {}));
var _Record;
(function (_Record) {
    _Record.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(_Record = exports._Record || (exports._Record = {}));
var RecordsIngested;
(function (RecordsIngested) {
    RecordsIngested.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RecordsIngested = exports.RecordsIngested || (exports.RecordsIngested = {}));
var RejectedRecord;
(function (RejectedRecord) {
    RejectedRecord.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(RejectedRecord = exports.RejectedRecord || (exports.RejectedRecord = {}));
class RejectedRecordsException extends TimestreamWriteServiceException_1.TimestreamWriteServiceException {
    constructor(opts) {
        super({
            name: "RejectedRecordsException",
            $fault: "client",
            ...opts,
        });
        this.name = "RejectedRecordsException";
        this.$fault = "client";
        Object.setPrototypeOf(this, RejectedRecordsException.prototype);
        this.Message = opts.Message;
        this.RejectedRecords = opts.RejectedRecords;
    }
}
exports.RejectedRecordsException = RejectedRecordsException;
var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceRequest = exports.TagResourceRequest || (exports.TagResourceRequest = {}));
var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceResponse = exports.TagResourceResponse || (exports.TagResourceResponse = {}));
var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceRequest = exports.UntagResourceRequest || (exports.UntagResourceRequest = {}));
var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceResponse = exports.UntagResourceResponse || (exports.UntagResourceResponse = {}));
var UpdateDatabaseRequest;
(function (UpdateDatabaseRequest) {
    UpdateDatabaseRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateDatabaseRequest = exports.UpdateDatabaseRequest || (exports.UpdateDatabaseRequest = {}));
var UpdateDatabaseResponse;
(function (UpdateDatabaseResponse) {
    UpdateDatabaseResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateDatabaseResponse = exports.UpdateDatabaseResponse || (exports.UpdateDatabaseResponse = {}));
var UpdateTableRequest;
(function (UpdateTableRequest) {
    UpdateTableRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateTableRequest = exports.UpdateTableRequest || (exports.UpdateTableRequest = {}));
var UpdateTableResponse;
(function (UpdateTableResponse) {
    UpdateTableResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateTableResponse = exports.UpdateTableResponse || (exports.UpdateTableResponse = {}));
var WriteRecordsRequest;
(function (WriteRecordsRequest) {
    WriteRecordsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(WriteRecordsRequest = exports.WriteRecordsRequest || (exports.WriteRecordsRequest = {}));
var WriteRecordsResponse;
(function (WriteRecordsResponse) {
    WriteRecordsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(WriteRecordsResponse = exports.WriteRecordsResponse || (exports.WriteRecordsResponse = {}));
