import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateDatabaseRequest, CreateDatabaseResponse } from "../models/models_0";
import { deserializeAws_json1_0CreateDatabaseCommand, serializeAws_json1_0CreateDatabaseCommand, } from "../protocols/Aws_json1_0";
var CreateDatabaseCommand = (function (_super) {
    __extends(CreateDatabaseCommand, _super);
    function CreateDatabaseCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateDatabaseCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamWriteClient";
        var commandName = "CreateDatabaseCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateDatabaseRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateDatabaseResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateDatabaseCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0CreateDatabaseCommand(input, context);
    };
    CreateDatabaseCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0CreateDatabaseCommand(output, context);
    };
    return CreateDatabaseCommand;
}($Command));
export { CreateDatabaseCommand };
