import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteDatabaseRequest } from "../models/models_0";
import { deserializeAws_json1_0DeleteDatabaseCommand, serializeAws_json1_0DeleteDatabaseCommand, } from "../protocols/Aws_json1_0";
var DeleteDatabaseCommand = (function (_super) {
    __extends(DeleteDatabaseCommand, _super);
    function DeleteDatabaseCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteDatabaseCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamWriteClient";
        var commandName = "DeleteDatabaseCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteDatabaseRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteDatabaseCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0DeleteDatabaseCommand(input, context);
    };
    DeleteDatabaseCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0DeleteDatabaseCommand(output, context);
    };
    return DeleteDatabaseCommand;
}($Command));
export { DeleteDatabaseCommand };
