import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CreateDatabaseRequest, CreateDatabaseResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamWriteClientResolvedConfig } from "../TimestreamWriteClient";
export interface CreateDatabaseCommandInput extends CreateDatabaseRequest {
}
export interface CreateDatabaseCommandOutput extends CreateDatabaseResponse, __MetadataBearer {
}

export declare class CreateDatabaseCommand extends $Command<CreateDatabaseCommandInput, CreateDatabaseCommandOutput, TimestreamWriteClientResolvedConfig> {
    readonly input: CreateDatabaseCommandInput;
    constructor(input: CreateDatabaseCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamWriteClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateDatabaseCommandInput, CreateDatabaseCommandOutput>;
    private serialize;
    private deserialize;
}
