import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DescribeDatabaseRequest, DescribeDatabaseResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamWriteClientResolvedConfig } from "../TimestreamWriteClient";
export interface DescribeDatabaseCommandInput extends DescribeDatabaseRequest {
}
export interface DescribeDatabaseCommandOutput extends DescribeDatabaseResponse, __MetadataBearer {
}

export declare class DescribeDatabaseCommand extends $Command<DescribeDatabaseCommandInput, DescribeDatabaseCommandOutput, TimestreamWriteClientResolvedConfig> {
    readonly input: DescribeDatabaseCommandInput;
    constructor(input: DescribeDatabaseCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamWriteClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeDatabaseCommandInput, DescribeDatabaseCommandOutput>;
    private serialize;
    private deserialize;
}
