import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ListDatabasesRequest, ListDatabasesResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamWriteClientResolvedConfig } from "../TimestreamWriteClient";
export interface ListDatabasesCommandInput extends ListDatabasesRequest {
}
export interface ListDatabasesCommandOutput extends ListDatabasesResponse, __MetadataBearer {
}

export declare class ListDatabasesCommand extends $Command<ListDatabasesCommandInput, ListDatabasesCommandOutput, TimestreamWriteClientResolvedConfig> {
    readonly input: ListDatabasesCommandInput;
    constructor(input: ListDatabasesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamWriteClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListDatabasesCommandInput, ListDatabasesCommandOutput>;
    private serialize;
    private deserialize;
}
