import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { UpdateDatabaseRequest, UpdateDatabaseResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamWriteClientResolvedConfig } from "../TimestreamWriteClient";
export interface UpdateDatabaseCommandInput extends UpdateDatabaseRequest {
}
export interface UpdateDatabaseCommandOutput extends UpdateDatabaseResponse, __MetadataBearer {
}

export declare class UpdateDatabaseCommand extends $Command<UpdateDatabaseCommandInput, UpdateDatabaseCommandOutput, TimestreamWriteClientResolvedConfig> {
    readonly input: UpdateDatabaseCommandInput;
    constructor(input: UpdateDatabaseCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamWriteClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateDatabaseCommandInput, UpdateDatabaseCommandOutput>;
    private serialize;
    private deserialize;
}
