import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { WriteRecordsRequest, WriteRecordsResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamWriteClientResolvedConfig } from "../TimestreamWriteClient";
export interface WriteRecordsCommandInput extends WriteRecordsRequest {
}
export interface WriteRecordsCommandOutput extends WriteRecordsResponse, __MetadataBearer {
}

export declare class WriteRecordsCommand extends $Command<WriteRecordsCommandInput, WriteRecordsCommandOutput, TimestreamWriteClientResolvedConfig> {
    readonly input: WriteRecordsCommandInput;
    constructor(input: WriteRecordsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamWriteClientResolvedConfig, options?: __HttpHandlerOptions): Handler<WriteRecordsCommandInput, WriteRecordsCommandOutput>;
    private serialize;
    private deserialize;
}
